PGOBLIN_BANG(-f)
  Copyright (C)2024 @BABOLO http://www.babolo.ru/
  pkg = lrwi-helorussia
  All rights reserved.

  Redistribution and use in source and binary forms, with or without
  modification, are permitted provided that the following conditions
  are met:
  1. Redistributions of source code must retain the above copyright
     notice, this list of conditions and the following disclaimer.
  2. Redistributions in binary form must reproduce the above copyright
     notice, this list of conditions and the following disclaimer in the
     documentation and/or other materials provided with the distribution.

  THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
  ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
  OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
  HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
  LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
  OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  SUCH DAMAGE.

  $Id: lrwi-helorussia.pgoblin.m4,v 1.12 2025/02/02 20:51:24 babolo Exp $

lRwI_PreA
#perform 0002  ##########################################################################    ####
CREATE TABLE IF NOT EXISTS SQNM(levh)                   --  
     ( SQAT(levh)  INTEGER PRIMARY KEY AUTOINCREMENT      --  
     , SQAT(name)  text    NOT NULL                       -- 
     , SQAT(ordr)  int                                    -- 
     ) STRICT
;
#perform 0002
INSERT OR REPLACE
 INTO SQNM(levh)(SQAT(levh), SQAT(name), SQAT(ordr))
 VALUES ( 0, ' '           , 99)
--    , ( 1, ' '                , 99)
--    , ( 2, '  ', 99)
;
#perform 0002  #######################################################################    ####
CREATE TABLE IF NOT EXISTS SQNM(labo)                   --  
     ( SQAT(levh)  int     NOT NULL REFERENCES SQNM(levh) --  
     , SQAT(labo)  INTEGER PRIMARY KEY AUTOINCREMENT      --  
     , SQAT(name)  text    NOT NULL                       -- 
     , SQAT(ordr)  int                                    -- 
     ) STRICT
;
#perform 0002
INSERT OR REPLACE
 INTO SQNM(labo)(SQAT(levh), SQAT(labo), SQAT(name), SQAT(ordr))
 VALUES ( 0,  0, ':  '              , 99)
--    , ( 0,  1, '   '              , 99)
      , ( 0,  2, '   '        , 99)
      , ( 0,  3, ' '                           , 99)
      , ( 0, 10, '  '            , 99)
--    , ( 1,  4, ':    ', 99)
--    , ( 1,  5, '   '              , 99)
--    , ( 1,  6, ' '                           , 99)
--    , ( 2,  7, ':    ', 99)
--    , ( 2,  8, '   '              , 99)
--    , ( 2,  9, ' '                           , 99)
;
#perform 0002  ###########################################################################    ####
CREATE TABLE IF NOT EXISTS SQNM(kurs)                   --  
     ( SQAT(labo)  int     NOT NULL REFERENCES SQNM(labo) --  
     , SQAT(kurs)  INTEGER PRIMARY KEY AUTOINCREMENT      --  
     , SQAT(name)  text    NOT NULL                       -- 
     , SQAT(ordr)  int                                    -- 
     ) STRICT
;
#perform 0002
INSERT OR REPLACE
 INTO SQNM(kurs)(SQAT(labo), SQAT(kurs), SQAT(name), SQAT(ordr))
 VALUES ( 0,  0, ' ' , 99)
      , ( 0,  1, ' ', 99)
--    , ( 1,  2, ' ' , 99)
--    , ( 1,  3, ' ', 99)
      , ( 2,  4, ' ' , 99)
      , ( 2,  5, ' ', 99)
      , ( 3,  6, ' ' , 99)
      , ( 3,  7, ' ', 99)
--    , ( 4,  8, ' ' , 99)
--    , ( 4,  9, ' ', 99)
--    , ( 5, 10, ' ' , 99)
--    , ( 5, 11, ' ', 99)
--    , ( 6, 12, ' ' , 99)
--    , ( 6, 13, ' ', 99)
--    , ( 7, 14, ' ' , 99)
--    , ( 7, 15, ' ', 99)
--    , ( 8, 16, ' ' , 99)
--    , ( 8, 17, ' ', 99)
      , (10, 18, ' ', 99)
;
#perform 0002  ###########################################################################    ####
CREATE TABLE IF NOT EXISTS SQNM(less)                   --  
     ( SQAT(kurs)  int     NOT NULL REFERENCES SQNM(kurs) --  
     , SQAT(less)  INTEGER PRIMARY KEY AUTOINCREMENT      --  
     , SQAT(name)  text    NOT NULL                       -- 
     , SQAT(ordr)  int                                    -- 
     ) STRICT
;
#perform 0002
INSERT OR REPLACE
 INTO SQNM(less)(SQAT(kurs), SQAT(less), SQAT(name), SQAT(ordr))
 VALUES ( 0,  8, '  '                     , 99)
      , ( 1,  0, '  '                    , 95)
      , ( 1,  1, '  '                   , 95)
      , ( 1,  2, '  '                   , 95)
      , ( 1,  3, ' ף '                 , 95)
      , ( 1,  4, '  '                    , 96)
      , ( 1,  5, '  '                   , 96)
      , ( 1, 12, '  '                   , 96)
      , ( 1,  6, '  '                   , 99)
      , ( 1,  7, '  '                   , 99)
      , ( 1, 16, '  '              , 99)
      , ( 1, 17, '  '               , 99)
      , ( 1, 18, '  '               , 99)
      , ( 1, 19, '  '             , 99)
      , ( 1, 20, '  '               , 99)
      , ( 4,  9, ' ף '                 , 99)
      , ( 4, 10, '  '                     , 99)
      , ( 6, 11, '  '                   , 99)
      , ( 7, 13, '"   "', 99)
      , (18, 14, ' "",  1-5'          , 99)
      , (18, 15, ' 1-8'                          , 99)
      , ( 5, 21, '  10.  '       , 99)
;
#perform 0002  ##########################################################################    ####
CREATE TEMP TABLE SQNM(tempqans)            -- 
     ( SQAT(objc) int  NOT NULL               -- 
     , SQAT(poin) int  NOT NULL               --  
     , SQAT(answ) text NOT NULL               -- 
     , SQAT(full) text                        --  
     , PRIMARY KEY(SQAT(objc), SQAT(poin))
     ) STRICT
;
#exec    _  #################################################################     ####
/bin/sh
#
-c
#
cat THISDIR/../p/*.copy
#copyin  00_2
COPY SQNM(tempqans) FROM stdin;
#wait
#close   _0_
#perform 0002
CREATE TEMP TABLE SQNM(tmpqans)             -- 
     ( SQAT(objc) int  NOT NULL               --  
     , SQAT(poin) int  NOT NULL               --  
     , SQAT(vrnt) int  NOT NULL               --   
     , SQAT(answ) text NOT NULL               -- 
     , SQAT(full) text                        --  
     , PRIMARY KEY(SQAT(objc), SQAT(poin), SQAT(vrnt), SQAT(answ))
     ) STRICT
;
#perform 0002
WITH a AS(SELECT SQAT(objc)
               , SQAT(poin)
               , 0                                              AS SQAT(vrnt)
               , CASE WHEN regexp('^[0-9]+$', SQAT(answ))
                      THEN CAST(MIN(CAST(SQAT(answ) AS INTEGER)) AS TEXT)
                      ELSE MIN(SQAT(answ))
                 END                                            AS SQAT(answ)
           FROM SQNM(tempqans)
          GROUP BY SQAT(objc), SQAT(poin)
         UNION
          SELECT SQAT(objc)
               , SQAT(poin)
               , 1                                              AS SQAT(vrnt)
               , CASE WHEN regexp('^[0-9]+$', SQAT(answ))
                      THEN CAST(MAX(CAST(SQAT(answ) AS INTEGER)) AS TEXT)
                      ELSE MIN(SQAT(answ))
                 END                                            AS SQAT(answ)
           FROM SQNM(tempqans)
          GROUP BY SQAT(objc), SQAT(poin)
          HAVING COUNT(1) > 1
         )
INSERT INTO SQNM(tmpqans)
 SELECT SQAT(objc), SQAT(poin), SQAT(vrnt), SQAT(answ), SQAT(full)
  FROM a JOIN SQNM(tempqans) USING(SQAT(objc), SQAT(poin), SQAT(answ))
;
#begin   0002  ###############################################################     ####
#select  _002
DELETE FROM SQNM(qans)
 WHERE              (SQAT(objc), SQAT(poin), SQAT(vrnt), SQAT(answ))
       NOT IN(SELECT SQAT(objc), SQAT(poin), SQAT(vrnt), SQAT(answ) FROM SQNM(tmpqans))
   AND SQAT(proj) == LRWINUM
 RETURNING '-qans', *
;
#display 00_00q
#select  _002
UPDATE SQNM(qans)
   SET SQAT(full) = SQNM(tmpqans).SQAT(full)
 FROM SQNM(tmpqans)
 WHERE SQNM(tmpqans).SQAT(objc) == SQNM(qans).SQAT(objc)
   AND SQNM(tmpqans).SQAT(poin) == SQNM(qans).SQAT(poin)
   AND SQNM(tmpqans).SQAT(vrnt) == SQNM(qans).SQAT(vrnt)
   AND SQNM(tmpqans).SQAT(answ) == SQNM(qans).SQAT(answ)
   AND SQNM(tmpqans).SQAT(full) IS NOT SQNM(qans).SQAT(full)
 RETURNING '~qans', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(qans)
 SELECT LRWINUM, * FROM SQNM(tmpqans)
 RETURNING '+qans', *
;
#display 00_00q
#end     0002
#perform 0002  ################################################################   N  1  ####
CREATE TEMP TABLE SQNM(tmpcomb)                        -- 
     ( SQAT(proj)  int NOT NULL                          -- 
     , SQAT(objc)  int NOT NULL                          -- 
     , SQAT(poin)  int NOT NULL                          --  
     , SQAT(ordr)  int                                   --   
     , SQAT(sdem)  int                                   -- 
     , SQAT(demo)  int  NOT NULL DEFAULT 0               --  
     , PRIMARY KEY(SQAT(proj), SQAT(objc), SQAT(poin))
     ) STRICT
;
#perform 0002  ###########################################################     ####
INSERT INTO SQNM(tmpcomb)
 VALUES ( LRWINUM, 21, 21, 55, NULL, 1)
;
#begin   0002  ############################################################     ####
#select  _002
DELETE FROM SQNM(comb)
 WHERE (SQAT(objc), SQAT(poin)) NOT IN(SELECT SQAT(objc), SQAT(poin) FROM SQNM(tmpcomb))
   AND SQAT(proj) == LRWINUM
 RETURNING '-comb', *
;
#display 00_00q
#select  _002
UPDATE SQNM(comb)
   SET SQAT(ordr) = SQNM(tmpcomb).SQAT(ordr)
     , SQAT(sdem) = SQNM(tmpcomb).SQAT(sdem)
     , SQAT(demo) = SQNM(tmpcomb).SQAT(demo)
 FROM SQNM(tmpcomb)
 WHERE SQNM(tmpcomb).SQAT(proj) == SQNM(comb).SQAT(proj)
   AND SQNM(tmpcomb).SQAT(objc) == SQNM(comb).SQAT(objc)
   AND SQNM(tmpcomb).SQAT(poin) == SQNM(comb).SQAT(poin)
   AND (  SQNM(tmpcomb).SQAT(ordr) IS NOT SQNM(comb).SQAT(ordr)
       OR SQNM(tmpcomb).SQAT(sdem) IS NOT SQNM(comb).SQAT(sdem)
       OR SQNM(tmpcomb).SQAT(demo) IS NOT SQNM(comb).SQAT(demo)
       )
 RETURNING '~comb', *
;
#display 00_00q
#select  _002
INSERT OR IGNORE INTO SQNM(comb)
 SELECT * FROM SQNM(tmpcomb)
 RETURNING '+comb', *
;
#display 00_00q
#end     0002
#perform 0002  ######################################################################   ####
INSERT OR REPLACE
 INTO SQNM(proj)(SQAT(proj), SQAT(name), SQAT(ordr), SQAT(vizi), SQAT(pnam), SQAT(anno))
 VALUES( LRWINUM, '", !"', 999, 1, 'lrwi-helorussia', NULL)
;
lRwI_PosA
#
